@---this procedure calculate the p-values for Volkanov bounds test--@
#include simuvolk/proc/cowork2.prc;/**/

proc(1)=volkbounds(x,y,horizons,bound,retn);
local nobs,hor,cvdf3_a,cvdf_a,maxp,pstar,junk,aat,cim;
local vnam,m,b,stb,vc,stderr,sigma,cx,rsq,resid,dwstat;
local cribounds,cribtemp,volleft,volright,tstatlh,volcrilh;
local r1,r2,dhat,dhat1,omega;
local aa1,aa2;
local ressup,kk,ylhor,xyprilh,yylh,xxlh;
local namlh,mlh,blh,stblh,vclh,stdlh,siglh,cxlh,rsqlh,residlh,dbwlh,tstat;
local fomat1,fomat2,vv1,vv2,vv3,vv4,crr,volcri;
local h,indh,fomat3,fomat4,volcri1,volcri2,pv,pp;
local cc,cc2,cc3,cc4,ccvolk,nmsup,volcrippr;
local crc;
__output=0;
@------Volkanov bounds test----@
cc2=seqa(-40,0.5,50); /*all c values*/
cc3=seqa(-15,0.2,100);
cc4=seqa(5,0.5,10);
cc = cc2|cc3|cc4;

ccvolk={-10,-5,-1,-0.5,0}; /*this is the version for Volkanov paper, comment this out if use the full version*/

nmsup=indnvle(ccvolk,cc);


nobs=rows(x);
hor={1,10,30,50,70,110,130};
load path=/share2/wei/ cvdf3_a;
cvdf_a=cvdf3_a[1,.]|sortc(cvdf3_a[2:rows(cvdf3_a),.],1);
clear cvdf3_a;

maxp = 6;  /* largest lag in BIC in first stage*/
/*cim = (0.99-1)*strtof(T);*/
{pstar,junk}=urbic(x,1,maxp+1);
{aat,junk}=adf(x,1,pstar);

{cim}=unitci(aat[2,1],0.0,cvdf_a);
_olsres=1;
{ vnam,m,b,stb,vc,stderr,sigma,cx,rsq,resid,dwstat } 
= ols(0,y,x);




r1 = x[2:rows(x),1]-(1+cim[1]/nobs)*x[1:rows(x)-1,1];
r2 = resid[1:rows(resid)-1]; 

{dhat,omega}=deltahat(r1,r2,1,rows(r2),maxp);
dhat=dhat[1,2];
dhat1=dhat;

/**** select the right critical value matrix*******/


/*---select and interpolate to get cv's-----*/
/* here we select the correct critical value matrices depending on delta
  and interpolate */

if dhat<=-0.95;aa1=-95;aa2=-95;dhat=10;
elseif dhat<-0.9;aa1=-95;aa2=-90;dhat=10;
elseif dhat<-0.8;aa1=-90;aa2=-80;dhat=10;
elseif dhat<-0.7;aa1=-80;aa2=-70;dhat=10;
elseif dhat<-0.6;aa1=-70;aa2=-60;dhat=10;
elseif dhat<-0.5;aa1=-60;aa2=-50;dhat=10;
elseif dhat<-0.4;aa1=-50;aa2=-40;dhat=10;
elseif dhat<-0.3;aa1=-40;aa2=-30;dhat=10;
elseif dhat<-0.2;aa1=-30;aa2=-20;dhat=10;
elseif dhat<-0.1;aa1=-20;aa2=-10;dhat=10;
elseif dhat<0;aa1=-10;aa2=0;dhat=10;/**/
elseif dhat<0.1;aa1=0;aa2=10;dhat=10;
elseif dhat<0.2;aa1=10;aa2=20;dhat=10;
elseif dhat<0.3;aa1=20;aa2=30;dhat=10;
elseif dhat<0.4;aa1=30;aa2=40;dhat=10;
elseif dhat<0.5;aa1=40;aa2=50;dhat=10;
elseif dhat<0.6;aa1=50;aa2=60;dhat=10;
elseif dhat<0.7;aa1=60;aa2=70;dhat=10;
elseif dhat<0.8;aa1=70;aa2=80;dhat=10;
elseif dhat<0.9;aa1=80;aa2=90;dhat=10;
elseif dhat<0.95;aa1=90;aa2=95;dhat=10;
else; aa1=95;aa2=95;
endif;



ressup=zeros(1,rows(horizons));
for kk (1,cols(ressup),1);
ylhor=mkyk(y,horizons[kk]);
xyprilh = packr(ylhor~x);

yylh = xyprilh[.,1];
xxlh = xyprilh[.,2];

{ namlh,mlh,blh,stblh,vclh,stdlh,siglh,cxlh,rsqlh,residlh,dbwlh } = ols(0,yylh,xxlh); 
tstat = blh[2]/stdlh[2];



    if horizons[kk]==1;
    
    if retn$=="indicator";

fomat1 = "simuvolk/fmtall/fmt1000new/"$+ftos(abs(aa1),"volkcri%*.*lf",1,0)$+ftos(horizons[kk],"_%*.*lf",1,0);
fomat2 = "simuvolk/fmtall/fmt1000new/"$+ftos(abs(aa2),"volkcri%*.*lf",1,0)$+ftos(horizons[kk],"_%*.*lf",1,0);
    elseif retn$=="pval";
fomat1 = "simuvolk/fmtall/fmt1000/"$+ftos(abs(aa1),"volkdat%*.*lf",1,0)$+ftos(horizons[kk],"_%*.*lf",1,0);
fomat2 = "simuvolk/fmtall/fmt1000/"$+ftos(abs(aa2),"volkdat%*.*lf",1,0)$+ftos(horizons[kk],"_%*.*lf",1,0);
    endif;


load vv1 = ^fomat1;load vv2 = ^fomat2;

crc = 1;
do until crc>cols(vv1);
vv1[.,crc]=sortc(vv1[.,crc],1);
vv2[.,crc]=sortc(vv2[.,crc],1);
crc = crc + 1;
endo;

volcri = zeros(rows(vv1),cols(vv1));

crr = 1;

do until crr>rows(volcri);
  if aa1==aa2;
  volcri[crr,.]=vv1[crr,.];
  else;

  volcri[crr,.] = lint(abs(dhat1)*100,vv1[crr,.]|vv2[crr,.],abs(aa1)|abs(aa2));
  
  /*volcri[crr,.] = lint(dhat1*100,vv1[crr,.]|vv2[crr,.],aa1|aa2);*/
  endif;
crr=crr+1;
endo;

else;  /*if k\==1*/

h=horizons[kk]/nobs*1000;
h=fix(h);
   if h>maxc(hor);
   indh=rows(hor)-1;
   else;
   indh=indnvle(h,hor);
   endif;

   if retn$=="indicator";

fomat1 = "simuvolk/fmtall/fmt1000/"$+ftos(abs(aa1),"volkcri%*.*lf",1,0)$+ftos(hor[indh],"_%*.*lf",1,0);
fomat2 = "simuvolk/fmtall/fmt1000/"$+ftos(abs(aa2),"volkcri%*.*lf",1,0)$+ftos(hor[indh],"_%*.*lf",1,0);

fomat3 = "simuvolk/fmtall/fmt1000/"$+ftos(abs(aa1),"volkcri%*.*lf",1,0)$+ftos(hor[indh+1],"_%*.*lf",1,0);
fomat4 = "simuvolk/fmtall/fmt1000/"$+ftos(abs(aa2),"volkcri%*.*lf",1,0)$+ftos(hor[indh+1],"_%*.*lf",1,0);

   elseif retn$=="pval";

fomat1 = "simuvolk/fmtall/fmt1000/"$+ftos(abs(aa1),"volkdat%*.*lf",1,0)$+ftos(hor[indh],"_%*.*lf",1,0);
fomat2 = "simuvolk/fmtall/fmt1000/"$+ftos(abs(aa2),"volkdat%*.*lf",1,0)$+ftos(hor[indh],"_%*.*lf",1,0);

fomat3 = "simuvolk/fmtall/fmt1000/"$+ftos(abs(aa1),"volkdat%*.*lf",1,0)$+ftos(hor[indh+1],"_%*.*lf",1,0);
fomat4 = "simuvolk/fmtall/fmt1000/"$+ftos(abs(aa2),"volkdat%*.*lf",1,0)$+ftos(hor[indh+1],"_%*.*lf",1,0);

   endif;

load vv1 = ^fomat1;load vv2 = ^fomat2;
load vv3 = ^fomat3;load vv4 = ^fomat4;

crc = 1;
do until crc>cols(vv1);
vv1[.,crc]=sortc(vv1[.,crc],1);
vv2[.,crc]=sortc(vv2[.,crc],1);
vv3[.,crc]=sortc(vv3[.,crc],1);
vv4[.,crc]=sortc(vv4[.,crc],1);
crc = crc + 1;
endo;


volcri=zeros(rows(vv1),cols(vv1));
volcri1 = zeros(rows(vv1),cols(vv1));
volcri2 = zeros(rows(vv1),cols(vv1));
crr = 1;

do until crr>rows(volcri1);
  
  if aa1==aa2;
  volcri1[crr,.]=vv1[crr,.],; volcri2[crr,.]=vv3[crr,.];
   else;
  volcri1[crr,.] = lint(abs(dhat1)*100,vv1[crr,.]|vv2[crr,.],abs(aa1)|abs(aa2));
  volcri2[crr,.] = lint(abs(dhat1)*100,vv3[crr,.]|vv4[crr,.],abs(aa1)|abs(aa2));
endif;
crr=crr+1;
endo;

crr=1;
do until crr>rows(volcri);
volcri[crr,.]=lint(h,volcri1[crr,.]|volcri2[crr,.],hor[indh indh+1]);
crr=crr+1;
endo;

endif;

volcri=volcri[.,2:cols(volcri)];



local indstat;
if bound$=="sup";


@------sup bounds test-----@
volcrippr=volcri[.,nmsup];

   if retn$=="indicator";
cribounds = zeros(2,1);

if horizons[kk]==1;
  if h1$=="two sided";
  cribtemp=maxc(volcrippr[37,.]')|minc(volcrippr[5,.]');
  else;
  cribtemp=maxc(volcrippr[5,.]')|minc(volcrippr[4,.]');
  endif;
cribounds=sortc((dhat1/abs(dhat1)).*cribtemp,1);
volleft = tstat.< cribounds[1];
  volleft=1+volleft;
volright = tstat.>cribounds[2];
  volright=1+volright;
indstat=tstat./abs(tstat);
else;
tstatlh=tstat/sqrt(nobs);
volcrilh=volcrippr/sqrt(1000);
  if h1$=="two sided";
  cribtemp=maxc(volcrilh[37,.]')|minc(volcrilh[5,.]');
  else;
  cribtemp=maxc(volcrilh[5,.]')|minc(volcrilh[4,.]');
  endif;

cribounds=sortc((dhat1/abs(dhat1)).*cribtemp,1);
volleft = tstatlh.< cribounds[1];/****/
 volleft=1+volleft;/** gives the sign of the test**/
volright = tstatlh.>cribounds[2];
 volright=1+volright; /** gives the sign of the test**/
indstat=tstatlh./abs(tstatlh);
endif;

    if h1$=="two sided";
    ressup[1,kk] = indstat.*(volleft + volright); /** gives the sign of the tests**/
    elseif h1$=="left sided";
    ressup[1,kk]=volleft;
    elseif h1$=="right sided";
    ressup[1,kk]=volright;
    endif; 

   elseif retn$=="pval";
  pv=zeros(cols(volcrippr),1);
  
  pp=1;
  do until pp>rows(pv);
 
     if horizons[kk]==1;
     pv[pp,1]=meanc(dotfle(dhat1/abs(dhat1)*volcrippr[.,pp],tstat));  
     if pv[pp,1]>0.5;
     pv[pp,1]=1-pv[pp,1];
       endif;
      
     else;
       tstatlh=tstat/sqrt(nobs);
       
       volcrilh=volcrippr/sqrt(1000);
       
       pv[pp,1]=meanc(dotfle(volcrilh[.,pp],tstatlh));
         if dhat1/abs(dhat1)<0;
       pv[pp,1]=meanc(dotfle(-volcrilh[.,pp],tstatlh));
          endif;
      if pv[pp,1]>0.5; 
       pv[pp,1]=1-pv[pp,1];
      endif;

     endif;
  pp=pp+1;
  endo;
        
  if h1$=="two sided";
     ressup[1,kk]=2*maxc(pv);
  else;
     ressup[1,kk]=maxc(pv);
  endif;
endif;

endif;

endfor;  /* for kk loop */

retp(ressup);

endp;

