proc(3) = lhregnw(p,dp,d,m);

/* Computes d-horizon regression of p on dp; p and dp must have same number of
rows (observations).  d is the horizon and m is the number of
autocorrelation matrices included in the Newey-West estimator */

/* Returns ols coefficients, Newey-West hac t-statistics and R-squared */

local T,rd,x,y,it,b,u,s,tb,R2;

            T = rows(p);
            rd = p[(d+1):T,.] - p[1:T-d,.];
            x = dp[1:T-d,.] - meanc(dp[1:T-d,.])';
            y = rd-meanc(rd);
            iT= rows(y);
            b=inv(x'x)*x'y;
            u=y-x*b;
            S=hacnw(x,u,m);
            tb=b./sqrt(diag(iT*inv(x'x)*S*inv(x'x)));
            R2=(stdc(x*b)/stdc(y))^2;

retp(b,tb,R2);
endp;

